//MyWinBufferFile.cpp
#include <assert.h>
#include <time.h>
#include "MyFileType.h"
#include "MyWinBufferFile.h"

//-----------------------------------------------------------------------------
MyWinBufferFile::MyWinBufferFile()
: m_pBuffer(NULL)
{
}
//-----------------------------------------------------------------------------
MyWinBufferFile::~MyWinBufferFile()
{
	this->Close();
}
//-----------------------------------------------------------------------------
bool MyWinBufferFile::Open(LPCTSTR szFileName)
{
	HANDLE hFile = ::CreateFile(
		szFileName,
		GENERIC_READ, 
		FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL,
        OPEN_EXISTING, 
		0,
        0);

	if(hFile != INVALID_HANDLE_VALUE)
		m_fileName = szFileName;
	else
		return false;

	DWORD fileSize = (DWORD)GetSize(hFile);
	m_pBuffer = new unsigned char[fileSize+1];
	memset(m_pBuffer, 0, fileSize+1);

	DWORD readSize = Read(hFile, m_pBuffer, fileSize);
	::CloseHandle(hFile);

	if(readSize != fileSize)
	{
		Close();
		return false;
	}
	else
		return true;
}
//-----------------------------------------------------------------------------
void MyWinBufferFile::Close()
{
	if(m_pBuffer)
	{
		delete [] m_pBuffer;
		m_pBuffer = NULL;
		m_fileName.clear();
	}
}
//-----------------------------------------------------------------------------
void MyWinBufferFile::CloseFile(HANDLE fileHandle)
{
	if(fileHandle != INVALID_HANDLE_VALUE)   
	{
		::CloseHandle(fileHandle);
		m_fileName.clear();
	}
}
//-----------------------------------------------------------------------------
DWORD MyWinBufferFile::Read(HANDLE fileHandle, void* pBuffer,DWORD numBytes)
{
	assert(this);

	DWORD numRead = 0;   
	::ReadFile(fileHandle, pBuffer, numBytes, &numRead, 0);   
	return numRead; 
}
//-----------------------------------------------------------------------------
bool MyWinBufferFile::Exists()
{
	return (m_pBuffer != NULL);
}
//-----------------------------------------------------------------------------
LONGLONG MyWinBufferFile::GetSize(HANDLE fileHandle)
{
	LARGE_INTEGER liSize;
	liSize.QuadPart = 0;
	BOOL res = ::GetFileSizeEx(fileHandle, &liSize);   
	
	if(res == FALSE)
		return 0;
	return liSize.QuadPart;
}


